#!/bin/sh

# findinstalled.sh
# script to find files installed by specific packages on a Slackware-based distro
# ...grepping around in /var/log/packages :)
# script by Paul Sherman <psherma1@rochester.rr.com>
# GPL2 and above, naturally -----------------------

# in case of some previous error (like unplugging the computer in the middle of running the script)
# this will make sure the tempfile we use is cleared out.
rm -f $HOME/FIND_INSTALLED_OUTPUT

# make temp file for output right away -- did this to avoid trouble with fast machines
# that looked for results from "touch"-ed file too quickly :)
touch $HOME/FIND_INSTALLED_OUTPUT

DIALOG=Xdialog
$DIALOG  --icon /usr/share/pixmaps/tux-grey.xpm  --title "Check if a file was installed" \
        --inputbox "Enter a filename below.\n \
		The results will tell you if the file has been installed. \n \
		Aditionally, the PACKAGE that installed the file and\n \
		WHERE it was installed will be listed." 16 60 2> $HOME/inputbox.tmp.$$

retval=$?

input=`cat $HOME/inputbox.tmp.$$`
rm -f $HOME/inputbox.tmp.$$ 2>/dev/null

case $retval in
  0)
    #echo "Input string is '$input'"
	if [ ${#input} -lt "3" ]; then
			DIALOG=Xdialog
			$DIALOG --rc-file /usr/share/pixmaps/colorboxDOH.rc  --icon /usr/share/pixmaps/doh.xpm  --title "What was that?" \
		        --msgbox "\nSorry but...                  \n\nYou have to enter a filename\nor the results will be meaningless.\n" 0 0
			$0 & # recall this script in the background
			exit 0
	fi
	#touch $HOME/FIND_INSTALLED_OUTPUT
	Xdialog --title "Search results for $input" --no-cancel --logbox $HOME/FIND_INSTALLED_OUTPUT 16 60 &
	grep -R "$input" /var/log/packages | sed -e 's/\/var\/log\/packages\//PACKAGE= /' -e 's/:/   FILE= \//' >> $HOME/FIND_INSTALLED_OUTPUT
	if [ ! -s $HOME/FIND_INSTALLED_OUTPUT ]; then
		echo "No results found." >> $HOME/FIND_INSTALLED_OUTPUT
	fi
	rm -f $HOME/FIND_INSTALLED_OUTPUT 2>/dev/null;;
  1)
    echo "Find operation cancelled.";;
  255)
    echo "Find box rudely closed.";;
esac

# OK, I'm killing the file to death . . . ;-)
# I just don't like junk hanging around.
rm -f $HOME/FIND_INSTALLED_OUTPUT 2>/dev/null
exit 0
